#include "Common.h"
#define SPEEDTAXI 3
private ["_nim", "_plane", "_cs", "_reply", "_cont", "_ele", "_dest", "_delay", 
         "_resource", "_pos", "_dir", "_cat", "_catNr", "_pilot"];

_nim = [_this, 0, ObjNull] call BIS_fnc_param;


// bad idea, needs to come from available spawn places in the Nimitz
_ele = ["E1", "E2", "E3"] call BIS_fnc_selectRandom;

_resource = _nim getVariable "ttt_fo_resources";

// exit if no free spots available
if (!(_ele in _resource)) exitWith {};

// assign callsign
_cs = [_nim] call TeTeT_fnc_callsign;

_pilot = createGroup west;
"B_Pilot_F" createUnit [[0,0,0], _pilot];
_pilot setGroupId [_cs];
_pilot = leader _pilot;
_pilot allowDamage false;

// spawn the plane
_plane = [_nim, _ele] call TeTeT_fnc_spawn;
_plane setVehicleVarName _cs;
_plane setVelocity [0, 0, 0];
// disable killing the crew
// {_x setDamage 1} forEach crew _plane;
// set marker
[_plane, _cs, "b_plane", "ColorBlue", 1] call TeTeT_fnc_marker;

// prepare first request, hangar to elevator
_plane setVariable ["ttt_fo_callsign", _cs];
_plane setVariable ["ttt_fo_type", "req"];
_plane setVariable ["ttt_fo_resType", "ELE"];
_plane setVariable ["ttt_fo_res", [_ele]];

_cont = false;
_delay = 0;

while {!_cont} do {
  sleep _delay;
  _delay = _delay + 1;
  ttt_fo_messages set [count ttt_fo_messages, _plane];
  [_pilot, Salt, format ["requesting elevator %1", _ele]] call TeTeT_fnc_radio;

  waitUntil { _reply = _plane getVariable "ttt_fo_request"; !isNil "_reply" };
  _plane setVariable ["ttt_fo_request", nil];

  [format ["Got an answer: %1", _reply]] call TeTeT_fnc_debug;
  _cont = _reply;
};

format ["Permission granted to go for %1", _ele] call TeTeT_fnc_debug;

[_nim, _plane, _ele] call TeTeT_fnc_pushOnElevator;

// we're on top of the elevator now, at the flightdeck level, but not cleared of the elevator yet
["Plane on flightdeck"] call TeTeT_fnc_debug;

_catNr = [1, 2, 3] call BIS_fnc_selectRandom;
_cat = format ["C%1", _catNr];

_plane setVariable ["ttt_fo_type", "req"];
_plane setVariable ["ttt_fo_resType", "TAX"];
_plane setVariable ["ttt_fo_res", [_cat, "D"]];

_cont = false;
_delay = 5;
while {!_cont} do {
  sleep _delay;
  _delay = _delay + 1;
  ttt_fo_messages set [count ttt_fo_messages, _plane];
  [_pilot, Salt, format ["requesting taxi to catapult %1", _cat]] call TeTeT_fnc_radio;
  waitUntil { _reply = _plane getVariable "ttt_fo_request"; !isNil "_reply" };
  _plane setVariable ["ttt_fo_request", nil];

  [format ["Got an answer: %1", _reply]] call TeTeT_fnc_debug;
  _cont = _reply;
};

[format ["Got permission to taxi to %1", _cat]] call TeTeT_fnc_debug;

[_nim, _plane, _ele, _cat] call TeTeT_fnc_taxi;

[format ["At catapult %1", _cat]] call TeTeT_fnc_debug;

// releasing elevator and deck
_plane setVariable ["ttt_fo_type", "rel"];
_plane setVariable ["ttt_fo_res", [_ele, "D"]];
ttt_fo_messages set [count ttt_fo_messages, _plane];
waitUntil { _reply = _plane getVariable "ttt_fo_request"; !isNil "_reply" };
_plane setVariable ["ttt_fo_request", nil];

// take-ff request
_plane setVariable ["ttt_fo_type", "req"];
_plane setVariable ["ttt_fo_resType", "T-O"];
_plane setVariable ["ttt_fo_res", ["TO"]];

_cont = false;
_delay = 5;
while {!_cont} do {
  sleep _delay;
  _delay = _delay + 1;
  ttt_fo_messages set [count ttt_fo_messages, _plane];
  [_pilot, Salt, format ["requesting take-off"]] call TeTeT_fnc_radio;
  waitUntil { _reply = _plane getVariable "ttt_fo_request"; !isNil "_reply" };
  _plane setVariable ["ttt_fo_request", nil];

  [format ["Got an answer: %1", _reply]] call TeTeT_fnc_debug;
  _cont = _reply;
};

[_nim, _plane, _catNr, _cs] call TeTeT_fnc_planeStart;

// release resources
_plane setVariable ["ttt_fo_type", "rel"];
_plane setVariable ["ttt_fo_res", [_cat, "TO"]];
ttt_fo_messages set [count ttt_fo_messages, _plane];
waitUntil { _reply = _plane getVariable "ttt_fo_request"; !isNil "_reply" };
_plane setVariable ["ttt_fo_request", nil];

// flight operation
[_plane] call TeTeT_fnc_flightplan;

// initiate landing
waitUntil {_plane distance Approach3 < 1600};

// take-ff request
_plane setVariable ["ttt_fo_type", "req"];
_plane setVariable ["ttt_fo_resType", "LND"];
_plane setVariable ["ttt_fo_res", ["D", "E4"]];

_cont = false;
_delay = 10;
while {!_cont} do {
  sleep _delay;
  _delay = _delay + 1;
  ttt_fo_messages set [count ttt_fo_messages, _plane];
  waitUntil { _reply = _plane getVariable "ttt_fo_request"; !isNil "_reply" };
  [_pilot, Salt, format ["requesting landing"]] call TeTeT_fnc_radio;
  _plane setVariable ["ttt_fo_request", nil];

  [format ["Got an answer: %1", _reply]] call TeTeT_fnc_debug;
  _cont = _reply;
};

[_plane, Approach3] call TeTeT_fnc_touchdown;

[_nim, _plane, "L1", "E4"] call TeTeT_fnc_taxi;

_plane setVariable ["ttt_fo_type", "rel"];
_plane setVariable ["ttt_fo_res", ["D", "E4"]];
ttt_fo_messages set [count ttt_fo_messages, _plane];
waitUntil { _reply = _plane getVariable "ttt_fo_request"; !isNil "_reply" };
_plane setVariable ["ttt_fo_request", nil];

["All resources freed"] call TeTeT_fnc_debug;

[_plane, _nim] call TeTeT_fnc_deletePlane;
[_pilot, Salt, format ["signing off"]] call TeTeT_fnc_radio;
deleteVehicle _pilot;
deleteMarker _cs;

true;
